<?php

// Colour Options 

function chameleon_add_theme_page() {

	if ( $_GET['page'] == basename(__FILE__) ) {
		if ( 'save' == $_REQUEST['action'] ) {
			update_option( 'Chameleon_ImageColour', $_REQUEST[ 'set_ImageColour' ] );
			header("Location: themes.php?page=functions.php&saved=true");
			die;
		} else if( 'reset' == $_REQUEST['action'] ) {
			delete_option( 'Chameleon_ImageColour' );
			header("Location: themes.php?page=functions.php&reset=true");
			die;
		}
	}

    add_theme_page("Chameleon Theme Options", __('Colour Options','chameleon'), 'edit_themes', basename(__FILE__), 'chameleon_theme_page');
}

function chameleon_theme_page() {
	if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.__('Settings saved.','chameleon').'</strong></p></div>';
	if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.__('Settings reset.','chameleon').'</strong></p></div>';

?>

<div class="wrap">
<h1>Chameleon Colour Options</h1>
<p>Chameleon <?php _e('was designed by','chameleon'); ?> <a href="http://webgazette.co.uk">Ainslie Johnson</a>.</p>

<h3><?php _e('Available Image Colours:','chameleon'); ?></h3>
<style>
ul.horizontal {padding-top: 5px; padding-bottom: 5px; width: 90%;}
.horizontal li {list-style: none; padding: 5px 0 5px 10px; margin: 10px; border: 1px solid #000000; font-weight: bold; color: #ffffff;}
li.blue { background: url(<?php bloginfo('template_url'); ?>/options/images/blue-header.jpg);}
li.green { background: url(<?php bloginfo('template_url'); ?>/options/images/green-header.jpg);}
li.red { background: url(<?php bloginfo('template_url'); ?>/options/images/red-header.jpg);}
li.orange { background: url(<?php bloginfo('template_url'); ?>/options/images/orange-header.jpg);}
li.pink { background: url(<?php bloginfo('template_url'); ?>/options/images/pink-header.jpg);}
li.black { background: url(<?php bloginfo('template_url'); ?>/options/images/black-header.jpg);}
.center {text-align: center;}
</style>

<ul class="horizontal">
<li class="blue"><?php _e('Blue','chameleon') ?></li>
<li class="green"><?php _e('Green','chameleon') ?></li>
<li class="red"><?php _e('Red','chameleon') ?></li>
<li class="orange"><?php _e('Orange','chameleon') ?></li>
<li class="pink"><?php _e('Pink','chameleon') ?></li>
<li class="black"><?php _e('Black','chameleon') ?></li>
</ul>
<h3><?php _e('Image Colour Settings','chameleon') ?></h3>
<form method="post">
<p><?php _e('Select colour from list:','chameleon') ?> 
<?php
	$value = get_settings( 'Chameleon_ImageColour' );
	    echo "<select name=\"set_ImageColour\" style=\"width:200px;\" onchange=\"updateColour( this )\">";
		chameleon_input( "set_ImageColour", "option", __('Blue','chameleon'), "blue", $value );
		chameleon_input( "set_ImageColour", "option", __('Green','chameleon'), "green", $value );
		chameleon_input( "set_ImageColour", "option", __('Red','chameleon'), "red", $value );
		chameleon_input( "set_ImageColour", "option", __('Orange','chameleon'), "orange", $value );
		chameleon_input( "set_ImageColour", "option", __('Pink','chameleon'), "pink", $value );
		chameleon_input( "set_ImageColour", "option", __('Black','chameleon'), "black", $value );
		echo "</select>";
?>
</p>

<!-- Save Settings Button -->
<?php chameleon_input( "save", "submit", "", __('Save Settings','chameleon') ); ?>
<input type="hidden" name="action" value="save" />
</form>

</div>

<?php
}

add_action('admin_menu', 'chameleon_add_theme_page');

function chameleon_input( $var, $type, $description = "", $value = "", $selected="" ) {
 	echo "\n";
	switch( $type ){
		case "submit":
	 		echo "<p class=\"submit\"><input name=\"$var\" type=\"$type\" value=\"$value\" /></p>";
			break;

		case "option":
			if( $selected == $value ) { $extra = "selected=\"true\""; }
			echo "<option value=\"$value\" $extra >$description</option>";
		    break;
 	}
}


// Widget Settings

if ( function_exists('register_sidebar') )
	register_sidebar(array(
		'name' => 'Top Sidebar',
		'before_widget' => '', // Removes <li>
		'after_widget' => '', // Removes </li>
		'before_title' => '<h2>',
		'after_title' => '</h2>',
	));

if ( function_exists('register_sidebar') )
	register_sidebar(array(
		'name' => 'Left Sidebar',
		'before_widget' => '', // Removes <li>
		'after_widget' => '', // Removes </li>
		'before_title' => '<h2>',
		'after_title' => '</h2>',
	));

if ( function_exists('register_sidebar') )
	register_sidebar(array(
		'name' => 'Right Sidebar',
		'before_widget' => '', // Removes <li>
		'after_widget' => '', // Removes </li>
		'before_title' => '<h2>',
		'after_title' => '</h2>',
	));

// RSS Feeds 	
	function widget_chemeleon_rss() {
?>
	<h2>Subscribe</h2>
	<ul>
		<li><a href="<?php bloginfo('rss2_url'); ?>">Entries (RSS)</a></li>
		<li><a href="<?php bloginfo('comments_rss2_url'); ?>">Comments (RSS)</a></li>
	</ul>
<?php
}
if ( function_exists('register_sidebar_widget') )
    register_sidebar_widget(__('RSS Feeds'), 'widget_chemeleon_rss');

// Recent Posts 	
	function widget_chemeleon_recent() {
?>
<h2>Recent Posts</h2>
<ul class="right-links">
	<?php wp_get_archives('type=postbypost&limit=10'); ?>
</ul>
<?php
}
if ( function_exists('register_sidebar_widget') )
    register_sidebar_widget(__('Recent Posts'), 'widget_chemeleon_recent');
	 	 
// Meta 	
	function widget_chemeleon_meta() {
?>
<h2>Meta</h2>
	<ul>
		<?php wp_register(); ?>
		<li><?php wp_loginout(); ?></li>
		<?php wp_meta(); ?>
	</ul>
<?php
}
if ( function_exists('register_sidebar_widget') )
    register_sidebar_widget(__('Meta'), 'widget_chemeleon_meta');
	 	
// Search 	
	function widget_chemeleon_search() {
?>
	<div class="search">
		<?php include (TEMPLATEPATH . '/searchform.php'); ?>
	</div>
<?php
}
if ( function_exists('register_sidebar_widget') )
    register_sidebar_widget(__('Search'), 'widget_chemeleon_search');

// Pages 	
	function widget_chemeleon_pages() {
?>
<h2>Pages</h2>
<ul>
<li><a href="<?php echo get_settings('home'); ?>">Home</a></li>
<?php wp_list_pages('sort_column=menu_order&title_li=' ); ?> 
</ul>
<?php
}
if ( function_exists('register_sidebar_widget') )
    register_sidebar_widget(__('Pages'), 'widget_webgazette_Pages');
	

/*
Plugin Name: List Subpages
Plugin URI: http://pwnt.co.uk/blog/projects/plugins/wordpress/list-subpages/
Description: Adds a post tag that lists the sub pages of the current page, allowing you to use parent pages in a similar way to categories.
Author: Rob Miller
Version: 1.0
Author URI: http://pwnt.co.uk/blog/
*/

function list_subpages($return = 0) {
	
	global $wpdb, $post;
	
	$current_page = $post->ID;
	
	while($current_page) {
		$page_query = $wpdb->get_row("SELECT ID, post_title, post_parent FROM $wpdb->posts WHERE ID = '$current_page'");
		$current_page = $page_query->post_parent;
	}
	
	$parent_id = $page_query->ID;
	$parent_title = $page_query->post_title;
	
	// Only display the message if there are actually subpages
	if($wpdb->get_results("SELECT * FROM $wpdb->posts WHERE post_parent = '$parent_id'")) {
		
echo'<div id="subpage"><ul><li>Sub-Pages: </li>';
		
$html = wp_list_pages("child_of=$parent_id&depth=$depth&echo=".(!$return)."&title_li=0");

echo'</ul></div>';

} 
	
	if($return) {
		return $html;
	} else {
		echo $html;
	}
	
}

function parse_list_subpages($content) {
	
	global $wpdb, $post;
	
	// Parsing non-static posts would just create unnecessary overhead, so... don't.
	if($post->post_status != 'static' || strpos($content, '<!--subpages-->') === false) {
		return $content;
	}
	
	$subpages = list_subpages(1);
	
	return str_replace('<!--subpages-->', $subpages, $content);
	
}

add_filter('the_content', 'parse_list_subpages');

?>